C*****************************************
       program grid points
C*****************************************
       implicit none
	   include 'common.fi'

       write(6,*) '================================================='
	   write(6,*) ' PROGRAM IS USED TO WRITE POINTS AT WHICH TO '
	   write(6,*) ' SAMPLE DISTRIBUTIONS FOR 2D PROJECTIONS '
	   write(6,*) ' THE OUTPUT FILE IS NEEDED TO PLOT DISTRIBUTIONS '
	   write(6,*) ' '
	   write(6,*) ' rohrer@cmu.edu'
	   write(6,*) ' version 09/21/2019'
       write(6,*) '================================================='
	   
	   version = 'version 09/21/2019'

       !some constants that might be useful
       pi = 4.0*atan(1.0)
       !some formating statements used to format output

  4    format(I5)
  5    format(3(f9.6,1x))

       !Hexagonal
       !here we generate the sampling points.
       !the points near the north pole are close together,
       !so we use an ad hoc process in this area, so the points are not 
       !on top of each other and we can save some time
       cnt=1 !This integer labels the sampling point
       call AnglesToV (0, 0, n_1) !north pole: polar coordinate = 0°
       samplPts(1,cnt)= n_1(1)
       samplPts(2,cnt)= n_1(2)
       samplPts(3,cnt)= n_1(3)
       i_plot=2 !polar coordinate = 3°
       do j_plot=1,10     !Azimuthal coordinate: use four points
        theta_plot=3.0*float(i_plot-1)*(pi/180.0)  ! take integer to an angle
        phi_plot=5.0*float(j_plot-1)*(pi/180.0)   ! take integer to an angle
        call AnglesToV (theta_plot, phi_plot, n_1) ! take spherical angles to vector n_1
        cnt=cnt+1
        samplPts(1,cnt)= n_1(1)
        samplPts(2,cnt)= n_1(2)
        samplPts(3,cnt)= n_1(3)
       enddo
       i_plot=3 !polar coordinate = 6°
       do j_plot=1,14     !Azimuthal coordinate: use four points rotated from 3°
        theta_plot=3.0*float(i_plot-1)*(pi/180.0)  ! take integer to an angle
        phi_plot=4.0*float(j_plot-1)*(pi/180.0)    ! take integer to an angle
        call AnglesToV (theta_plot, phi_plot, n_1) ! take spherical angles to vector n_1
        cnt=cnt+1
        samplPts(1,cnt)= n_1(1)
        samplPts(2,cnt)= n_1(2)
        samplPts(3,cnt)= n_1(3)
       enddo
       !for all remaining polar coordinates, sample azimuth every 3°
       do i_plot=4,16       !Polar coodinate
        !do j_plot=1,121     !Azimuthal coordinate
        do j_plot=1,16     !Azimuthal coordinate
         theta_plot=3.0*float(i_plot-1)*(pi/180.0)  ! take integer to an angle
         phi_plot=3.0*float(j_plot-1)*(pi/180.0)    ! take integer to an angle
         call AnglesToV (theta_plot, phi_plot, n_1) ! take spherical angles to vector n_1
        cnt=cnt+1
        samplPts(1,cnt)= n_1(1)
        samplPts(2,cnt)= n_1(2)
        samplPts(3,cnt)= n_1(3)
        enddo
       enddo

       num_samplPts=cnt ! set a constant

       open(30, file='grid_points.txt',status='unknown')
       write(30,4)num_samplPts
       do i=1,num_samplPts
        write(30,5)samplPts(1,i),samplPts(2,i), samplPts(3,i)
       enddo
       close(30)

       end






	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   